/***********************************************************************************/
/*** FILE WITH DECLARATIONS OF FIXED QUANTITIES, GLOBAL VARIABLES, AND FUNCTIONS ***/
/***********************************************************************************/

/***********************************************/
/** l_range of completeness - 20 is fiducial  **/
/***********************************************/
#define L_MAX_CALIB 20

/****************************************************************/
/** Above this value use asymptotic expressions for Wigner-3j  **/
/****************************************************************/
#define MIN_ELL_USE_APPROX 50 // min ell at which you start using the approx expression

/****************************/
/***  Global variables  ****/ 
/****************************/
int Z_BINS,  Z_BIN_PAIRS;
int **l2_arr, *l2_1D_arr; 
int L_BINS, *l_arr, L_MAX;

double **Usq_l_m_l2_m2;
double ***alm_RE, ***alm_IM;

int SIZE_INDEX1, SIZE_INDEX2;

/****************************/
/***   Global functions  ****/ 
/****************************/

double R(int l1, int l2, int l3, int m1, int m2, int m3);
int justm_2index_compressed(int il, int m);
int lm_2index_compressed (int il,int m);
int l2m2_2index_compressed (int il, int l2,  int m2);
int file_eof_linecount (char *filename);
int count_words_in_row_of_file(char *filename);

void generate_U_Usq_single_l(int il, double ***c_arr); 

void calculate_Tl(double ***c_arr, double **Cl_all_ell, double *mag_to_calib_fac, double **Cl, double **Tl);

int condition(int l2, int l1, int l, int m2);
double epsilon(int iz,  double ***c_arr);
void get_alm(double **Cl_all_ell);

void assign_clm_given_Cl_calib (double *Cl, double ***clm_array); 
void assign_clm_given_fixed_rms(double delta_c, int lmax,double ***c_array);

int ij_to_alpha(int i, int j);
